/***************** CONSTRUCTOR oAviso **********************/
function oAviso() 
{
	this.nomVariable = 'aviso';
	this.idCapa = 'capaAviso';
	this.tipo = 'error';
	this.codError = 'codError';
	this.descBreve = 'descBreve';
	this.descLarga = 'descLarga';
    this.textoBtnAceptar = 'Aceptar';
	this.accionBtnAceptar = '';
	this.formulario = null;
    this.textoBtnCancelar = null;
	this.imgFondo = './igep/images/pestanyas/pix_trans.gif';
	this.rutaImg = './igep/images/avisos/';
	this.zIndice =  200; //ZIndex a partir del cual se trabaja
	this.ancho = 200; //Ancho de la capa de aviso
	this.alto = 200;//Alto de la capa de aviso
	
	//Tamao en pixels del espacio donde se visualiza la pgina.
	ie = (document.all)? true:false; //Cambia de IE al resto
	if(ie) 
	{
		this.anchoPagina = document.body.clientWidth;
		this.altoPagina = document.body.clientHeight;
	}
	else 
	{
		this.anchoPagina = innerWidth;
		this.altoPagina = innerHeight;
	}

	/*  Mtodos */
	this.mostrarAviso = f_oAviso_mostrarAviso;
	this.mostrarMensajeCargando = f_oAviso_mostrarMensajeCargando;
	this.set =f_oAviso_set;
	this.cerrarCapa = f_oAviso_cerrarCapa;
	this.capaBloqueo = f_oAviso_capaBloqueo;
	this.capaError = f_oAviso_capaError;
	this.enviaForm =	f_oAviso_enviaForm;
}

/******************* SET ***********************************************/
function f_oAviso_set(nombre, idCapa, tipo, codError, descBreve, descLarga, textoBtnCancelar, textoBtnAceptar, nombreForm, accionBtnAceptar)
{
	this.nomVariable = nombre;
	this.idCapa = idCapa;
	this.tipo = tipo.toUpperCase();
	this.codError = codError;
	this.descBreve = descBreve;
	this.descLarga = descLarga;
	this.textoBtnCancelar = textoBtnCancelar;
	if (textoBtnAceptar) this.textoBtnAceptar = textoBtnAceptar;	
	if ((nombreForm) && (nombreForm!='')) 
	{
		this.formulario = eval('document.forms["'+nombreForm+'"]');
	}
	else
	{
		this.formulario = document.forms[1];
	}
	if (accionBtnAceptar) this.accionBtnAceptar = accionBtnAceptar;
}

function f_oAviso_enviaForm() 
{	
	if(this.accionBtnAceptar!='')
	{
		this.formulario.action = this.accionBtnAceptar;
	}	
	//this.formulario.target = '_self'; // No s pq estaba, necesitamos ejecutar el formulario x el oculto (09/03/2010)	
	this.formulario.submit();
	this.cerrarCapa();
}


/******************* CERRAR CAPA *************************************/
function f_oAviso_cerrarCapa(idObjGen) 
{	
	var capaAviso = null;
	capaAviso = eval('document.getElementById("'+this.idCapa+'")');
	capaAviso.style.display = "none";
	
	var capaBloqueo = document.getElementById("capaBloqueo");
  	document.body.removeChild(capaBloqueo);
  	
	if ((idObjGen!=null) && (idObjGen!=''))
	{				
		document.getElementById(idObjGen).focus();
	}	
}

/******************* Mostrar Aviso *************************************/
function f_oAviso_mostrarAviso(objetoGenerador)
{
	var capaAviso = null;
	var contenido = '';
	var imgBk = '';
	var cerrar = '';
	var idObjGenerador ='';

	if (objetoGenerador !== undefined)
	{		
		idObjGenerador = objetoGenerador.id;
	}
	else
	{
		idObjGenerador='';
	}
		
	//Creamos la capa de bloqueo
	this.capaBloqueo();
	
	//Creamos la capa de Error
	this.capaError();
	
	switch(this.tipo) //Segn el tipo de aviso...
	{
		case 'ERROR':
		case 'error':
			imgBk = this.rutaImg+'aviso-rojo.gif';
			cerrar = this.rutaImg+'cerrar-rojo.gif';
		break;
		
		case 'AVISO':
		case 'aviso':
			imgBk = this.rutaImg+'aviso-azul.gif';
			cerrar = this.rutaImg+'cerrar-azul.gif';
		break;
		
		case 'SUGERENCIA':
		case 'sugerencia':
			 imgBk = this.rutaImg+'aviso-verde.gif';
			 cerrar = this.rutaImg+'cerrar-verde.gif';
		break;
		
		case 'ALERTA':
		case 'alerta':
			imgBk = this.rutaImg+'aviso-amarillo.gif';
			cerrar = this.rutaImg+'cerrar-amarillo.gif';
		break;
		
		case 'CONFIRM':
		case 'confirm':
			imgBk = this.rutaImg+'aviso-verde.gif';
			cerrar = this.rutaImg+'cerrar-verde.gif';
		break;
	};
	
 	// Dibuja la ventana y fija el contenido de la capa
	//Formulario y campos ocultos para el manejo de mensajes
	contenido += '<table style="width: 350px; height: 250px; text-align:left; border: 2px solid grey; border-collapse: collapse;" cellpadding="0" cellspacing="0">';
	 	contenido += '<tr>';
			contenido += '<td>';
				contenido += '<table style="border-style: none; width:100%; height:100%; border-collapse: collapse;" cellpadding="0" cellspacing="0">';
					contenido += '<tr>';
						contenido += '<td style="border-style: none; width:100%; height:109px; border-collapse: collapse;" background='+imgBk+'>';
							contenido += '<table style="border-style: none; height:100%; border-collapse: collapse;"  cellpadding="0" cellspacing="0">';
								contenido += '<tr>';
									contenido += '<td style="border-style: none; width:20px;">&nbsp;</td>';
									contenido += '<td style="border-style: none; width:320px; vertical-align: top;" class="codigoerror" >&nbsp;'+this.codError+'</td>';
									contenido += '<td style="width: 15px; text-align:right; vertical-align: top;"><img src='+cerrar+' style="width: 11px; height:14px; border-style: none; " onClick="';
										contenido += this.nomVariable+'.cerrarCapa()" />&nbsp;';
									contenido +='</td>';
								contenido += '</tr>';
								contenido += '<tr>';
									contenido += '<td style="width: 15px;">&nbsp;</td>';
									contenido += '<td colspan="3" style="width: 15px; vertical-align: bottom;" class="avisocorto" >'+this.descBreve+'</td>';
								contenido += '</tr>';
							contenido += '</table>';
						contenido += '</td>';
					contenido += '</tr>';
					contenido += '<tr>';
						contenido +='<td style="width: 2%;" class="fondo_gris"></td>';
					contenido +='</tr>';
					contenido += '<tr>';
						contenido += '<td style="width: 100%;" bgcolor="#FFFFFF">';
						contenido += '<table style="border-style: none; height: 100%; width:100%; border-collapse: collapse;" cellpadding="0" cellspacing="0" >';
								contenido += '<tr>';
									contenido += '<td width="15" bgcolor="#FFFFFF">&nbsp;</td>';
									contenido += '<td align="left" bgcolor="#FFFFFF" valign="middle" class="avisolargo">'+this.descLarga+'</td>';
								contenido += '</tr>';
							contenido += '</table>';	
						contenido += '</td>';
					contenido += '</tr>';
					contenido += '<tr class="fondo_gris">';
						contenido += '<td style="height: 8%; text-align: right; " >';
							contenido += '<table style="border-style: none; text-align: right;" cellspacing="1" cellpadding="1" align="right">';
								contenido += '<tr>';
									contenido += '<td>';
		
									if ((this.textoBtnCancelar != null) || ((this.tipo == 'CONFIRM') || (this.tipo == 'confirm')))
									{
										contenido += '<button type="button" id="btnAceptar" name="btnAceptar" class="formularios boton" style="cursor:pointer" onmouseover="this.className=\'formularios boton_on\';" onmouseout="this.className=\'formularios boton\';" onClick="'+this.nomVariable+'.enviaForm();">';
											contenido += '<img style="border-style: none; " id="aceptar" src="igep/images/acciones/41.gif" />'+this.textoBtnAceptar;	
										contenido +='</button>';										
										
										contenido += '&nbsp;<button type="button" id="btnCancelar" name="btnCancelar" class="formularios boton" style="cursor:pointer" onmouseover="this.className=\'formularios boton_on\';" onmouseout="this.className=\'formularios boton\';" onClick="'+this.nomVariable+'.cerrarCapa();">';
											contenido += '<img style="border-style: none; " id="cancelar" src="igep/images/acciones/42.gif" />'+this.textoBtnCancelar;
										contenido +='</button>';
									}
									else 
									{
										contenido += '<button type="button" id="btnAceptar" name="btnAceptar" class="formularios boton" style="cursor:pointer" onmouseover="this.className=\'formularios boton_on\';" onmouseout="this.className=\'formularios boton\';" onClick="'+this.nomVariable+'.cerrarCapa(\''+idObjGenerador+'\');">';
											contenido += '<img style="border-style: none; " id="aceptar" src="igep/images/acciones/41.gif" />'+this.textoBtnAceptar;	
										contenido +='</button>';										
									}
									contenido += '</td>';
								contenido += '</tr>';
							contenido += '</table>';
						contenido += '</td>';
					contenido += '</tr>';
				contenido += '</table>';
			contenido += '</td>';
		contenido += '</tr>';
	contenido += '</table>';
	//Cierre Formulario
	//contenido +='<form>'
	capaAviso = eval('document.getElementById("'+this.idCapa+'")');
	capaAviso.innerHTML = contenido;
	capaAviso.style.display = 'block';
	document.getElementById('btnAceptar').focus();  
}

/******************** CREAR CAPA Bloqueo *********************************/
function f_oAviso_capaBloqueo() 
{
	//Si la capa de bloqueo no existe la crea.      
	if(document.getElementById("capaBloqueo")==null)
	{
		// crear la capa de bloqueo para explorer y para mozilla
		var nuevo = document.createElement("div");
		nuevo.id="capaBloqueo";
		nuevo.style.position="absolute";
		nuevo.style.zIndex=this.zIndice;
		nuevo.style.left=0;
		nuevo.style.top=0;
		nuevo.style.backgroundImage="url('"+this.imgFondo+"')";
		nuevo.style.width=this.anchoPagina;
		nuevo.style.height=this.altoPagina;
		document.body.appendChild(nuevo);		
	}
}

/******************** CREAR CAPA ERROR *********************************/

function f_oAviso_capaError() 
{
	var capa = this.idCapa;	
	var msgTop, msgLeft;

	// calcular posicion de la capa de ventana de error
	msgLeft=Math.ceil((this.anchoPagina-this.ancho)/2);
	msgTop=Math.ceil((this.altoPagina-this.alto)/2);
	Z = parseInt(this.zIndice+2, 10);
	obj_capaError = eval('document.getElementById("'+this.idCapa+'")');
	obj_capaError.style.zIndex = Z;
	obj_capaError.style.width = this.ancho;
	obj_capaError.style.height = this.alto;	
	obj_capaError.style.left = msgLeft;
	obj_capaError.style.top = msgTop;	
	obj_capaError.style.display = "block";
}

/************************* CONTENIDO CAPA ERROR **************************/


/******************* Mostrar Aviso *************************************/
function f_oAviso_mostrarMensajeCargando(mensaje)
{
	var capaAviso = null;
	var contenido = '';
	var imgBk = '';
	var cerrar = '';

	//Creamos la capa de bloqueo
	this.capaBloqueo();
	
	//Creamos la capa de Error
	this.capaError();
	
	imgBk = this.rutaImg+'cargar.gif';	
		
	contenido += '<table style="text-align:center; border-collapse: collapse;" cellpadding="0" cellspacing="0" border=1>';	
	 	contenido += '<tr>';
	 	    contenido += '<td class="formularios cabecerainicial" style="align:center">';
	 	    contenido += '<table style="width: 50%; height: 50%;" border=0><tr>';
			contenido += '<td class="formularios fondo_inicio">';
				contenido += '';									
				contenido += '&nbsp;';				
				contenido += '<img style="border-style: none;" id="img_cargando" src="'+imgBk+'" /> ';
				contenido += '';									
			contenido += '</td></tr>';
			contenido += '<tr><td class="formularios cargando" align="center">';
				contenido += mensaje;
			contenido += '</td>';
		contenido += '</tr></table></td></tr>';
	contenido += '</table>';
	capaAviso = eval('document.getElementById("'+this.idCapa+'")');
	capaAviso.innerHTML = contenido;
	capaAviso.style.display = 'block';
}